/*
 * Harbor API
 * These APIs provide services for manipulating Harbor project.
 *
 * OpenAPI spec version: 2.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.19
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/ExtraAttrs'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./ExtraAttrs'));
  } else {
    // Browser globals (root is window)
    if (!root.HarborApi) {
      root.HarborApi = {};
    }
    root.HarborApi.Task = factory(root.HarborApi.ApiClient, root.HarborApi.ExtraAttrs);
  }
}(this, function(ApiClient, ExtraAttrs) {
  'use strict';

  /**
   * The Task model module.
   * @module model/Task
   * @version 2.0
   */

  /**
   * Constructs a new <code>Task</code>.
   * @alias module:model/Task
   * @class
   */
  var exports = function() {
  };

  /**
   * Constructs a <code>Task</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Task} obj Optional instance to populate.
   * @return {module:model/Task} The populated <code>Task</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();
      if (data.hasOwnProperty('id'))
        obj.id = ApiClient.convertToType(data['id'], 'Number');
      if (data.hasOwnProperty('execution_id'))
        obj.executionId = ApiClient.convertToType(data['execution_id'], 'Number');
      if (data.hasOwnProperty('status'))
        obj.status = ApiClient.convertToType(data['status'], 'String');
      if (data.hasOwnProperty('status_message'))
        obj.statusMessage = ApiClient.convertToType(data['status_message'], 'String');
      if (data.hasOwnProperty('run_count'))
        obj.runCount = ApiClient.convertToType(data['run_count'], 'Number');
      if (data.hasOwnProperty('extra_attrs'))
        obj.extraAttrs = ExtraAttrs.constructFromObject(data['extra_attrs']);
      if (data.hasOwnProperty('creation_time'))
        obj.creationTime = ApiClient.convertToType(data['creation_time'], 'String');
      if (data.hasOwnProperty('update_time'))
        obj.updateTime = ApiClient.convertToType(data['update_time'], 'String');
      if (data.hasOwnProperty('start_time'))
        obj.startTime = ApiClient.convertToType(data['start_time'], 'String');
      if (data.hasOwnProperty('end_time'))
        obj.endTime = ApiClient.convertToType(data['end_time'], 'String');
    }
    return obj;
  }

  /**
   * The ID of task
   * @member {Number} id
   */
  exports.prototype.id = undefined;

  /**
   * The ID of task execution
   * @member {Number} executionId
   */
  exports.prototype.executionId = undefined;

  /**
   * The status of task
   * @member {String} status
   */
  exports.prototype.status = undefined;

  /**
   * The status message of task
   * @member {String} statusMessage
   */
  exports.prototype.statusMessage = undefined;

  /**
   * The count of task run
   * @member {Number} runCount
   */
  exports.prototype.runCount = undefined;

  /**
   * @member {module:model/ExtraAttrs} extraAttrs
   */
  exports.prototype.extraAttrs = undefined;

  /**
   * The creation time of task
   * @member {String} creationTime
   */
  exports.prototype.creationTime = undefined;

  /**
   * The update time of task
   * @member {String} updateTime
   */
  exports.prototype.updateTime = undefined;

  /**
   * The start time of task
   * @member {String} startTime
   */
  exports.prototype.startTime = undefined;

  /**
   * The end time of task
   * @member {String} endTime
   */
  exports.prototype.endTime = undefined;


  return exports;

}));
